#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <pigpio.h>
#include <unistd.h>
#include <time.h>
#include <string.h>
#include <linux/i2c-dev.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <sys/wait.h>
#include <signal.h>
#include "pigpiod_if2.h"
#include "DHTXXD.h"
#include <pthread.h>
//#include <my_global.h>
//#include <mysql.h>

#define NUM_PROCESSES 	6
#define fileDir_pm 				"/home/alarm/ws/data/"
#define fileDir_DHT 			"/home/alarm/ws/data/"
#define fileDir_BME 			"/home/alarm/ws/data/"
#define extension 			".csv"
#define MyLog				"/home/alarm/ws/log/log.txt"
#define PMPACKETSIZE 32
//logical ids of sensors
#define SensorSN_file   "/home/alarm/sensing_station_platform/SensorSN.txt"
#define LOGICAL_SENSOR_NUM 11
#define POSITION_FILE "/home/alarm/sensing_station_platform/position_number.txt"

int exists(const char *fname);
void  functionPM(int RX,int Sensor_Num);
void check_child_alive();

int pi;
int pins[NUM_PROCESSES] = {12, 16, 23, 18, 20, 3};
int sensor_id[NUM_PROCESSES]={7,8,9,10,11,12};//physical id of sensors
int Sensor_SN[LOGICAL_SENSOR_NUM];
int fd[2];//pipes
int fd_log;//folder for log
int fd_data;
int flags;//pipe flags
int ret;
float read_buffer[5];//read_buffer for pipe
float write_buffer[5];
pid_t pid_pm[4];
pid_t pid_DHT,pid_BME;
char child_alive[NUM_PROCESSES];//flags children death
char log_buffer[100];//buffer for log string
char time_buffer[16];//buffer for time string
char filePath[100];//buffer for filePath string
char *head_line;//buffer for first line of data file
int PM[2];
char write_string[150];
// char *server = "18.188.127.57";
// char *user = "emilio";
// char *password = "7866265_Qi"; /* set me first */
// char *database = "weather_station";
//MYSQL connection;
time_t t;
struct tm tm;
int position_number;

//read in logical ids of sensors from file
void readSensorSN()
{
    FILE* ifp;
    ifp = fopen (SensorSN_file, "r");
    int n = LOGICAL_SENSOR_NUM;


    //Sensor_SN = (int *) malloc (n * sizeof(int));

    for (int i=0; i<n; i++)
    {
      int j = 0;
      fscanf (ifp, "%d", &j);
      Sensor_SN[i]=j;
      //printf ("\n j = %d and Sensor_SN = %d", j, Sensor_SN[i]);
    }
    fclose(ifp);
}

void readPosition()
{
    FILE* ifp;
    ifp = fopen (POSITION_FILE, "r");
    //&position_number = (int *) malloc(sizeof(int));
    int j = 0;
    fscanf (ifp, "%d", &j);
    position_number=j;
    fclose(ifp);
}

void writeToLog()
{
	//used to write a log string to the log file
	fd_log=open(MyLog,O_RDWR|O_CREAT|O_APPEND,S_IRWXU|S_IRWXG|S_IRWXO);
	write(fd_log,log_buffer,strlen(log_buffer));
	close(fd_log);
	return;
}

/* int connect_mysql() //used to connect to mysql server
{
	//Create and initialize a connection handle object

	if (mysql_init(&connection) == NULL) {
		snprintf(log_buffer,sizeof(log_buffer),"Connection handle initialization failed !\n");
		writeToLog();
		return 1;
	}

	//Connect to MySQL server
	if (mysql_real_connect(&connection, server, user, password,
	database, 3306, NULL, 0) != NULL) {
		snprintf(log_buffer,sizeof(log_buffer),"Connection to remote MySQL server established\n");
		writeToLog();
	} else {

		snprintf(log_buffer,sizeof(log_buffer),"Connection attempt to remote MySQL failed !\n");
		writeToLog();
		return 1;
	}

	//Close the connection
	//mysql_close(&connection);
	return 0;
}

void insert_mysql(int sen)//to insert data into remote mysql database
{
	char query_string[200];
	if(sen<5)//pm
		snprintf(query_string,sizeof(query_string),"%s'%d-%02d-%02d %02d:%02d:%02d',NULL,NULL,%d,%d,%d,%d%s", "INSERT INTO weather VALUES(",tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec,PM[0], PM[1], (int)read_buffer[2],(int)read_buffer[3],")");
	if(sen==5)//dht22
		snprintf(query_string,sizeof(query_string),"%s'%d-%02d-%02d %02d:%02d:%02d',%.1f,%.1f,NULL,NULL,%d,%d%s", "INSERT INTO weather VALUES(",tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec,read_buffer[0], read_buffer[1], (int)read_buffer[2],(int)read_buffer[3],")");
	mysql_query(&connection, query_string);

 } */


 
void writeDataToFile() //to write data to local file
{
	if(!exists(filePath))//new file
	{
		fd_data=open(filePath,O_RDWR|O_CREAT|O_APPEND,S_IRWXU|S_IRWXG|S_IRWXO);
		write(fd_data, head_line,strlen(head_line));
		write(fd_data,write_string,strlen(write_string));
		close(fd_data);
	}
	else
	{
		fd_data=open(filePath,O_RDWR|O_CREAT|O_APPEND,S_IRWXU|S_IRWXG|S_IRWXO);
		write(fd_data,write_string,strlen(write_string));
		close(fd_data);
	}
}

void restart_uart(int RX) //in the case of problem in uart reading,restart uart
{
	bb_serial_read_close(pi,RX);//restart serial read
	sleep(1);
	bb_serial_read_open(pi, RX, 9600, 8);
}

//function to do measurement for PM sensors
void  functionPM(int RX,int SENSOR_ID)
{
	char data_pm[PMPACKETSIZE];
	sleep(15);
	int suma;
	//initialize pigpio attach to a daemon,default port 8888
	pi = pigpio_start(0, 0);
	set_mode(pi, RX, PI_INPUT);  // Set RX as input.
	bb_serial_read_open(pi, RX, 9600, 8);
	int count_data,count_notpass;
	int i;
	if (pi < 0)
	{

		printf("pigpio initialisation failed.");
		// pigpio initialisation failed.
		t = time(NULL);
		tm = *gmtime(&t);
		memset(log_buffer,0,sizeof(log_buffer));
		snprintf(log_buffer,sizeof(log_buffer),"pigpio initialisation failed at %d-%02d-%02d %d:%02d:%02d.\n",tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec);
		writeToLog();
		return ;
	}
	else
	{
		// pigpio initialised okay.
		t = time(NULL);
		tm = *gmtime(&t);
		memset(log_buffer,0,sizeof(log_buffer));
		snprintf(log_buffer,sizeof(log_buffer),"READING ON SOFTWARE SERIAL ON PIN %d ,sensor id %d  at %d-%02d-%02d %d:%02d:%02d.\n",RX,SENSOR_ID,tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec);
		writeToLog();
		while(1)
		{
            //readPosition();
			memset(data_pm,0,PMPACKETSIZE*sizeof(char));
			count_data=bb_serial_read(pi, RX, data_pm, sizeof(data_pm));
			//usleep(500000); //sleep for 500ms
			sleep(1);//wait data to be transmitted
			PM[0]=-10;
			PM[1]=-10;//initialise as meaningless values
			if(count_data>=PMPACKETSIZE)
			{
				if (data_pm[0] == 66 && data_pm[1] == 77)
				{
					//perform check
					suma = 0;
					for (i = 0;i < 30;i++)
						suma += data_pm[i];
					if (suma == data_pm[30] * 256 + data_pm[31])
					{
						write_buffer[0] = (int)(data_pm[6] * 256 + data_pm[7]);//pm2.5
						write_buffer[1] = (int)((data_pm[8] * 256 + data_pm[9]) / 0.75);//pm10
						write_buffer[2] = RX ; //pin number
						write_buffer[3] = SENSOR_ID;
						//printf("PM2.5:%d,PM10:%d,PIN%d\n",(int)write_buffer[0],(int)write_buffer[1],(int)write_buffer[2]);
						//close(fd[0]);
						write(fd[1], write_buffer, sizeof(write_buffer));//write to pipe
					}
					else
					{
						t = time(NULL);
						tm = *gmtime(&t);
						//printf("error1:check didn't pass on PIN %d ,sensor id %d  at %d-%02d-%02d %d:%02d:%02d.\n",RX,SENSOR_ID,tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec);
						memset(log_buffer,0,sizeof(log_buffer));
						snprintf(log_buffer,sizeof(log_buffer),"error1:check didn't pass on PIN %d ,sensor id %d  at %d-%02d-%02d %d:%02d:%02d.\n",RX,SENSOR_ID,tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec);
						writeToLog();
						count_notpass++;
						if(count_notpass>=2)
						{
							restart_uart(RX);
							count_notpass=0;
						}
					}
				}
				else
				{
					t = time(NULL);
					tm = *gmtime(&t);
					printf("error2:check didn't pass on PIN %d ,sensor id %d  at %d-%02d-%02d %d:%02d:%02d.\n",RX,SENSOR_ID,tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec);
					memset(log_buffer,0,sizeof(log_buffer));
					snprintf(log_buffer,sizeof(log_buffer),"error2:check didn't pass on PIN %d ,sensor id %d  at %d-%02d-%02d %d:%02d:%02d.\n",RX,SENSOR_ID,tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec);
					writeToLog();
					count_notpass++;
					if(count_notpass>=2)//data not pass over 10 times
					{
						restart_uart(RX);
						count_notpass=0;
					}
				}
			}
			//sleep(1);
			//usleep(40000);
		}
	}
	return ;
}

//routine of dht22 sensor--writing data into pipe.
void cbf(DHTXXD_data_t r)
{

   //printf("%d %.1f %.1f\n", r.status, r.temperature, r.humidity);
   if(r.status==0)//successful read
   {
		write_buffer[0] = r.temperature;//status
		write_buffer[1] = r.humidity;//temperature
		write_buffer[2] = pins[4];//pin number
		write_buffer[3] = sensor_id[4];//sensor_id of DHT
		write(fd[1], write_buffer, sizeof(write_buffer));//write to pipe
   }
}

//measurement for dht22
void functionDHT(int RX,int Sensor_Num)
{
	DHTXXD_t *dht;
	sleep(10);
	pi = pigpio_start(0, 0);
	dht = DHTXXD(pi, pins[4], DHTXX, cbf); /* Create DHTXX. */
	while(1)
	{
        //readPosition();
		DHTXXD_manual_read(dht);
		sleep(2);//read DHT22 every 2 seconds
	}
	return ;
}

void functionBME()
{
	// Create I2C bus
	int file;
	char *bus = "/dev/i2c-1";

 //
	time_t rawtime;
	struct tm * ptm;
//
    sleep(15);

    while(1)
    {
        sleep(1);
        //readPosition();
        if((file = open(bus, O_RDWR)) < 0)
        {
    //
            time ( &rawtime );
            ptm = gmtime ( &rawtime );
            printf("%d-%d-%d %d:%d:%d: Failed to open the bus. \n",ptm->tm_year, ptm->tm_mon, ptm->tm_mday, ptm->tm_hour, ptm->tm_min, ptm->tm_sec);
    //

            // printf("Failed to open the bus. \n");

            exit(1);
        }
        // Get I2C device, BME280 I2C address is 0x76(136)
        ioctl(file, I2C_SLAVE, 0x76);

        // Read 24 bytes of data from register(0x88)
        char reg[1] = {0x88};
        write(file, reg, 1);
        char b1[24] = {0};
        if(read(file, b1, 24) != 24)
        {
            //
                    time ( &rawtime );
                ptm = gmtime ( &rawtime );
                    printf("%d-%d-%d %d:%d:%d:Input/Output Error. \n",ptm->tm_year, ptm->tm_mon, ptm->tm_mday, ptm->tm_hour, ptm->tm_min, ptm->tm_sec);
            //

            // printf("Error : Input/Output error \n");
            exit(1);
        }

        // Convert the data
        // temp coefficents
        int dig_T1 = (b1[0] + b1[1] * 256);
        int dig_T2 = (b1[2] + b1[3] * 256);
        if(dig_T2 > 32767)
        {
            dig_T2 -= 65536;
        }
        int dig_T3 = (b1[4] + b1[5] * 256);
        if(dig_T3 > 32767)
        {
            dig_T3 -= 65536;
        }

        // pressure coefficents
        int dig_P1 = (b1[6] + b1[7] * 256);
        int dig_P2 = (b1[8] + b1[9] * 256);
        if(dig_P2 > 32767)
        {
            dig_P2 -= 65536;
        }
        int dig_P3 = (b1[10] + b1[11] * 256);
        if(dig_P3 > 32767)
        {
            dig_P3 -= 65536;
        }
        int dig_P4 = (b1[12] + b1[13] * 256);
        if(dig_P4 > 32767)
        {
            dig_P4 -= 65536;
        }
        int dig_P5 = (b1[14] + b1[15] * 256);
        if(dig_P5 > 32767)
        {
        dig_P5 -= 65536;
        }
        int dig_P6 = (b1[16] + b1[17] * 256);
        if(dig_P6 > 32767)
        {
            dig_P6 -= 65536;
        }
        int dig_P7 = (b1[18] + b1[19] * 256);
        if(dig_P7 > 32767)
        {
            dig_P7 -= 65536;
        }
        int dig_P8 = (b1[20] + b1[21] * 256);
        if(dig_P8 > 32767)
        {
        dig_P8 -= 65536;
        }
        int dig_P9 = (b1[22] + b1[23] * 256);
        if(dig_P9 > 32767)
        {
            dig_P9 -= 65536;
        }

        // Read 1 byte of data from register(0xA1)
        reg[0] = 0xA1;
        write(file, reg, 1);
        char data[8] = {0};
        read(file, data, 1);
        int dig_H1 = data[0];

        // Read 7 bytes of data from register(0xE1)
        reg[0] = 0xE1;
        write(file, reg, 1);
        read(file, b1, 7);

        // Convert the data
        // humidity coefficents
        int dig_H2 = (b1[0] + b1[1] * 256);
        if(dig_H2 > 32767)
        {
            dig_H2 -= 65536;
        }
        int dig_H3 = b1[2] & 0xFF ;
        int dig_H4 = (b1[3] * 16 + (b1[4] & 0xF));
        if(dig_H4 > 32767)
        {
            dig_H4 -= 65536;
        }
        int dig_H5 = (b1[4] / 16) + (b1[5] * 16);
        if(dig_H5 > 32767)
        {
            dig_H5 -= 65536;
        }
        int dig_H6 = b1[6];
        if(dig_H6 > 127)
        {
            dig_H6 -= 256;
        }

        // Select control humidity register(0xF2)
        // Humidity over sampling rate = 1(0x01)
        char config[2] = {0};
        config[0] = 0xF2;
        config[1] = 0x01;
        write(file, config, 2);
        // Select control measurement register(0xF4)
        // Normal mode, temp and pressure over sampling rate = 1(0x27)
        config[0] = 0xF4;
        config[1] = 0x27;
        write(file, config, 2);
        // Select config register(0xF5)
        // Stand_by time = 1000 ms(0xA0)
        config[0] = 0xF5;
        config[1] = 0xA0;
        write(file, config, 2);

        // Read 8 bytes of data from register(0xF7)
        // pressure msb1, pressure msb, pressure lsb, temp msb1, temp msb, temp lsb, humidity lsb, humidity msb
        reg[0] = 0xF7;
        write(file, reg, 1);
        read(file, data, 8);

        // Convert pressure and temperature data to 19-bits
        long adc_p = ((long)(data[0] * 65536 + ((long)(data[1] * 256) + (long)(data[2] & 0xF0)))) / 16;
        long adc_t = ((long)(data[3] * 65536 + ((long)(data[4] * 256) + (long)(data[5] & 0xF0)))) / 16;
        // Convert the humidity data
        long adc_h = (data[6] * 256 + data[7]);

        // Temperature offset calculations
        float var1 = (((float)adc_t) / 16384.0 - ((float)dig_T1) / 1024.0) * ((float)dig_T2);
        float var2 = ((((float)adc_t) / 131072.0 - ((float)dig_T1) / 8192.0) *
                        (((float)adc_t)/131072.0 - ((float)dig_T1)/8192.0)) * ((float)dig_T3);
        float t_fine = (long)(var1 + var2);
        float cTemp = (var1 + var2) / 5120.0;
        //float fTemp = cTemp * 1.8 + 32;

        // Pressure offset calculations
        var1 = ((float)t_fine / 2.0) - 64000.0;
        var2 = var1 * var1 * ((float)dig_P6) / 32768.0;
        var2 = var2 + var1 * ((float)dig_P5) * 2.0;
        var2 = (var2 / 4.0) + (((float)dig_P4) * 65536.0);
        var1 = (((float) dig_P3) * var1 * var1 / 524288.0 + ((float) dig_P2) * var1) / 524288.0;
        var1 = (1.0 + var1 / 32768.0) * ((float)dig_P1);
        float p = 1048576.0 - (float)adc_p;
        p = (p - (var2 / 4096.0)) * 6250.0 / var1;
        var1 = ((float) dig_P9) * p * p / 2147483648.0;
        var2 = p * ((float) dig_P8) / 32768.0;
        float pressure = (p + (var1 + var2 + ((float)dig_P7)) / 16.0) / 100;

        // Humidity offset calculations
        float var_H = (((float)t_fine) - 76800.0);
        var_H = (adc_h - (dig_H4 * 64.0 + dig_H5 / 16384.0 * var_H)) * (dig_H2 / 65536.0 * (1.0 + dig_H6 / 67108864.0 * var_H * (1.0 + dig_H3 / 67108864.0 * var_H)));
        float humidity = var_H * (1.0 -  dig_H1 * var_H / 524288.0);
        if(humidity > 100.0)
        {
            humidity = 100.0;
        }else
        if(humidity < 0.0)
        {
            humidity = 0.0;
        }

        // Output data to screen
        // printf("Temperature in Celsius : %.2f C \n", cTemp);
        // //printf("Temperature in Fahrenheit : %.2f F \n", fTemp);
        // printf("Pressure : %.2f hPa \n", pressure);
        // printf("Relative Humidity : %.2f RH \n", humidity);

        write_buffer[0] = cTemp;
		write_buffer[1] = humidity;
		write_buffer[2] = pins[5];
		write_buffer[3] = sensor_id[5];
        write_buffer[4] = pressure;
		write(fd[1], write_buffer, sizeof(write_buffer));//write to pipe
        
    }
}

//routine(triggered by alarm) for checking if children alive
void check_child_alive(int signum)
{
	int i;
	pid_t result;
	int status;

	alarm(60);//reset alarm
	//printf("checking.\n");
	for(i=0;i<NUM_PROCESSES;i++)
	{
		if(i<4)
			result = waitpid(pid_pm[i], &status, WNOHANG);
		if(i==4)
			result = waitpid(pid_DHT, &status, WNOHANG);
        if(i==5)
            result = waitpid(pid_BME, &status, WNOHANG);
		if(result == -1)//error
		{
			t = time(NULL);
			tm = *gmtime(&t);
			memset(log_buffer,0,sizeof(log_buffer));
			snprintf(log_buffer,sizeof(log_buffer),"waitpid error at %d-%02d-%02d %d:%02d:%02d.\n",tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec);
			writeToLog();
			//print in log
		}
		else
		{
			if (result == 0)
			{
				child_alive[i]=1;
				// Child still alive
			}
			else
			{
				//printf("%d died\n",result);
				child_alive[i]=0;
			}
		}
	}
}

//check if a file exists
int exists(const char *fname)
{
	FILE *file;
	if ((file = fopen(fname, "r")))
	{
		fclose(file);
		return 1;
	}
	return 0;
}

//restart a child in case it died for some reason
void restart_child()
{
	int i;
	for(i=0;i<NUM_PROCESSES;i++)//checked death and restart child
	{
		if(child_alive[i]==0)
		{
			t = time(NULL);
			tm = *gmtime(&t);
			memset(log_buffer,0,sizeof(log_buffer));
			snprintf(log_buffer,sizeof(log_buffer),"One child's death checked at %d-%02d-%02d %d:%02d:%02d.\n",tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec);
			writeToLog();
			if(i<4)
			{
				pid_pm[i]=fork();
				if(pid_pm[i]==0)//child
				{
					//alarm(0);//cancel alarm
					sleep(5);
					functionPM(pins[i],sensor_id[i]);
					exit(EXIT_FAILURE);
				}
				else
				{//parent
					child_alive[i]=1;
					//printf("%d is new child.\n",pid_pm[i]);
					t = time(NULL);
					tm = *gmtime(&t);
					memset(log_buffer,0,sizeof(log_buffer));
					snprintf(log_buffer,sizeof(log_buffer),"PID:%d for PM is new child.\n at %d-%02d-%02d %d:%02d:%02d.\n",pid_pm[i],tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec);
					writeToLog();
				}
			}
			if (i==4)
			{
				pid_DHT=fork();
				if(pid_DHT==0)//child
				{
					//alarm(0);//cancel alarm
					sleep(5);
					functionDHT(pins[i],sensor_id[i]);
					exit(EXIT_FAILURE);
				}
				else
				{//parent
					child_alive[i]=1;
					//printf("%d is new child.\n",pid_pm[i]);
					t = time(NULL);
					tm = *gmtime(&t);
					memset(log_buffer,0,sizeof(log_buffer));
					snprintf(log_buffer,sizeof(log_buffer),"PID:%d for dht is new child.\n at %d-%02d-%02d %d:%02d:%02d.\n",pid_DHT,tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec);
					writeToLog();
				}
			}
            if (i==5)
			{
				pid_BME=fork();
				if(pid_BME==0)//child
				{
					//alarm(0);//cancel alarm
					sleep(5);
					functionBME();
					exit(EXIT_FAILURE);
				}
				else
				{//parent
					child_alive[i]=1;
					//printf("%d is new child.\n",pid_pm[i]);
					t = time(NULL);
					tm = *gmtime(&t);
					memset(log_buffer,0,sizeof(log_buffer));
					snprintf(log_buffer,sizeof(log_buffer),"PID:%d for bme is new child.\n at %d-%02d-%02d %d:%02d:%02d.\n",pid_BME,tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec);
					writeToLog();
				}
			}
		}
	}
}

//read data from pipe and write them to disk
void write_to_disk()
{
	t = time(NULL);
	tm = *gmtime(&t);
    strftime(time_buffer, sizeof(time_buffer), "%Y%m%d", &tm);//get date as string
    //exact dir of file to write
    snprintf(filePath, sizeof(filePath), "%s%s%s", fileDir_pm, time_buffer,extension);
    head_line="datetime(UTC), SensorSN ,measure ,position_number\n";
	if((int)read_buffer[2]==12 || (int)read_buffer[2]==16 || (int)read_buffer[2]==18 || (int)read_buffer[2]==23)//PM
	{
		PM[0]=read_buffer[0];
		PM[1]=read_buffer[1];
		//from non-empty pipe
		if(PM[0]>=0&&PM[1]>=0)
		{

			memset(write_string,0,sizeof(write_string));
            switch((int)read_buffer[2])
            {
                case 12:
                    snprintf(write_string,sizeof(write_string),"%d-%02d-%02d %02d:%02d:%02d,%d,%d,%d\n%d-%02d-%02d %02d:%02d:%02d,%d,%d,%d\n", tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec,Sensor_SN[0],PM[0], position_number,tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec,Sensor_SN[1],PM[1], position_number);
                    break;
                case 16:
                    snprintf(write_string,sizeof(write_string),"%d-%02d-%02d %02d:%02d:%02d,%d,%d,%d\n%d-%02d-%02d %02d:%02d:%02d,%d,%d,%d\n", tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec,Sensor_SN[2],PM[0], position_number,tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec,Sensor_SN[3],PM[1], position_number);
                    break;
                case 18:
                    snprintf(write_string,sizeof(write_string),"%d-%02d-%02d %02d:%02d:%02d,%d,%d,%d\n%d-%02d-%02d %02d:%02d:%02d,%d,%d,%d\n", tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec,Sensor_SN[4],PM[0], position_number,tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec,Sensor_SN[5],PM[1], position_number);
                    break;
                case 23:
                    snprintf(write_string,sizeof(write_string),"%d-%02d-%02d %02d:%02d:%02d,%d,%d,%d\n%d-%02d-%02d %02d:%02d:%02d,%d,%d,%d\n", tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec,Sensor_SN[6],PM[0], position_number,tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec,Sensor_SN[7],PM[1], position_number);
                    break;
            }
			

			writeDataToFile();

			//insert_mysql((int)read_buffer[3]);
			// pthread_t tid;
			// snprintf(write_string,sizeof(write_string),"sudo mosquitto_pub  -h 18.188.127.57 -p 1883 -q 1 -d -t mypmevent -i client1 -m \"%d-%02d-%02d %d:%02d:%02d,,,%d,%d,%d,%d\n\"", tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec,PM[0], PM[1], (int)read_buffer[2],(int)read_buffer[3]);
			// pthread_create(&tid, NULL, &TestSend, NULL);
		}
	}
	if((int)read_buffer[2]==20)//dht22
	{
		memset(write_string,0,sizeof(write_string));
		//snprintf(write_string,sizeof(write_string),"%d-%02d-%02d %02d:%02d:%02d,%.1f,%.1f,,,,%d,%d\n", tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec, read_buffer[0], read_buffer[1],(int)read_buffer[2],(int)read_buffer[3]);
        snprintf(write_string,sizeof(write_string),"%d-%02d-%02d %02d:%02d:%02d,%d,%.1f,%d\n%d-%02d-%02d %02d:%02d:%02d,%d,%.1f,%d\n", tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec,Sensor_SN[8],read_buffer[0], position_number,tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec,Sensor_SN[9],read_buffer[1], position_number);
		writeDataToFile();

		//insert_mysql((int)read_buffer[3]);

	}

    if((int)read_buffer[2]==3)//bme280
	{
		memset(write_string,0,sizeof(write_string));
		//snprintf(write_string,sizeof(write_string),"%d-%02d-%02d %02d:%02d:%02d,%.2f,%.2f,%.2f,,,%d,%d\n", tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec, read_buffer[0], read_buffer[1],read_buffer[4],(int)read_buffer[2],(int)read_buffer[3]);
        snprintf(write_string,sizeof(write_string),"%d-%02d-%02d %02d:%02d:%02d,%d,%.2f,%d\n", tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec,Sensor_SN[10],read_buffer[4], position_number);
		writeDataToFile();

		//insert_mysql((int)read_buffer[3]);

	}
}

//creat one child for each sensor to start measurement
void creat_children()
{
	int i;
	for(i=0;i<NUM_PROCESSES;i++)
	{
		if(i<4)//for PM
		{
			pid_pm[i] = fork();

			if (pid_pm[i] == -1)
			{//fork fails

					t = time(NULL);
					tm = *gmtime(&t);
					memset(log_buffer,0,sizeof(log_buffer));
					snprintf(log_buffer,sizeof(log_buffer),"pin%d fork fails at %d-%02d-%02d %d:%02d:%02d.\n",pins[i],tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec);
					writeToLog();
					exit(EXIT_FAILURE);
			}
			if(pid_pm[i] == 0)//child
			{
				functionPM(pins[i],sensor_id[i]);
				pigpio_stop(pi);
				exit(EXIT_FAILURE);
			}
			if(pid_pm[i] > 0)//parent
			{
				t = time(NULL);
				tm = *gmtime(&t);
				//printf("pin%d child starts at %d-%02d-%02d %d:%02d:%02d.\n",pins[i],tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec);
				memset(log_buffer,0,sizeof(log_buffer));
				snprintf(log_buffer,sizeof(log_buffer),"pm pin%d child starts at %d-%02d-%02d %d:%02d:%02d.\n",pins[i],tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec);
				writeToLog();
			}
		}
		if(i==4)
		{
			pid_DHT = fork();

			if (pid_DHT == -1)
			{//fork fails

					t = time(NULL);
					tm = *gmtime(&t);
					memset(log_buffer,0,sizeof(log_buffer));
					snprintf(log_buffer,sizeof(log_buffer),"DHT pin%d fork fails at %d-%02d-%02d %d:%02d:%02d.\n",pins[i],tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec);
					writeToLog();
					exit(EXIT_FAILURE);
			}
			if(pid_DHT == 0)//child
			{
				functionDHT(pins[i],sensor_id[i]);
				return ;
			}
			if(pid_DHT > 0)//parent
			{
				t = time(NULL);
				tm = *gmtime(&t);
				//printf("pin%d child starts at %d-%02d-%02d %d:%02d:%02d.\n",pins[i],tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec);
				memset(log_buffer,0,sizeof(log_buffer));
				snprintf(log_buffer,sizeof(log_buffer),"DHT pin%d child starts at %d-%02d-%02d %d:%02d:%02d.\n",pins[i],tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec);
				writeToLog();
			}
		}
        if(i==5)//BME280
		{
			pid_BME = fork();

			if (pid_BME == -1)
			{//fork fails

					t = time(NULL);
					tm = *gmtime(&t);
					memset(log_buffer,0,sizeof(log_buffer));
					snprintf(log_buffer,sizeof(log_buffer),"BME280 fork fails at %d-%02d-%02d %d:%02d:%02d.\n",tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec);
					writeToLog();
					exit(EXIT_FAILURE);
			}
			if(pid_BME == 0)//child
			{
				functionBME();
				return ;
			}
			if(pid_BME > 0)//parent
			{
				t = time(NULL);
				tm = *gmtime(&t);
				//printf("pin%d child starts at %d-%02d-%02d %d:%02d:%02d.\n",pins[i],tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec);
				memset(log_buffer,0,sizeof(log_buffer));
				snprintf(log_buffer,sizeof(log_buffer),"BME280  child starts at %d-%02d-%02d %d:%02d:%02d.\n",tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec);
				writeToLog();
			}
		}

	}
}


int main(int argc, char const *argv[])
{
	struct sigaction sa;

    readSensorSN();
    readPosition();
    //sleep(2);
	pipe(fd);

	creat_children();

	memset(&sa, 0, sizeof(sa));
	sa.sa_handler = check_child_alive;
	sigaction(SIGALRM, &sa, NULL);// check child all alive
	alarm(1);

	//close(fd[1]);//closing pipes in writing, because we only want to read
	//flags = fcntl(fd[0],F_GETFL);
	//fcntl(fd[0],F_SETFL,flags|O_NONBLOCK);//don't block read if pipe is empty

	sleep(2);//wait for the first check
	//connect_mysql();
	while(read(fd[0], read_buffer, sizeof(read_buffer)))
	{
		write_to_disk();
		restart_child();
		// ret=read(fd[0], read_buffer, sizeof(read_buffer));
		// if(ret == -1)//results from empty pipe
		// {
			// continue;
		// }
		// else

	}
	return 0;
}
