-- run this script to create database
-- and tables for weather station data
-- example : "mysql -u emilio -p < /home/alarm/sensing_station_server/database/create_tables.sql" in bash
CREATE DATABASE WEATHER_STATION;
USE WEATHER_STATION;
-- creat table for measurement data
-- sensorSN is logical ID of sensor
CREATE TABLE `MEASURE_TABLE`
(`sensorSN` INT NOT NULL,
`timestamp` DATETIME NOT NULL,
`positionNo` INT NOT NULL,
`measure` FLOAT NOT NULL,
`future_1` FLOAT NULL,
`future_2` FLOAT NULL,
`future_3` FLOAT NULL,
PRIMARY KEY(sensorSN,timestamp))
ENGINE=InnoDB DEFAULT CHARSET=utf8;
-- creat table for position
CREATE TABLE  `POSITION_TABLE`
(`positionNo` INT NOT NULL,
`GPS_lng` FLOAT NULL,
`GPS_lat` FLOAT NULL,
`GPS_alt` FLOAT NULL,
PRIMARY KEY(positionNo))
ENGINE=InnoDB DEFAULT CHARSET=utf8;
-- creat table for sensor information
-- sensorID is physical ID of sensor
CREATE TABLE `SENSOR_TABLE`
(`sensorSN` INT NOT NULL,
`boardID` INT NOT NULL,
`PIN` TINYINT NOT NULL,
`farnell` VARCHAR(40) NULL,
`sensorID` INT NOT NULL,
`kind` VARCHAR(40) NOT NULL,
`unit` VARCHAR(40) NOT NULL,
`future_1` FLOAT NULL,
`future_2` FLOAT NULL,
`future_3` FLOAT NULL,
PRIMARY KEY(sensorSN))
ENGINE=InnoDB DEFAULT CHARSET=utf8;
-- creat table for board information
CREATE TABLE `BOARD_TABLE`
(`boardID` INT NOT NULL,
`kind` VARCHAR(40) NOT NULL,
`MAC` VARCHAR(40) NOT NULL,
`IP` VARCHAR(40) NOT NULL,
`SW_VERSION` VARCHAR(40) NOT NULL,
`future_1` FLOAT NULL,
`future_2` FLOAT NULL,
`future_3` FLOAT NULL,
PRIMARY KEY(boardID))
ENGINE=InnoDB DEFAULT CHARSET=utf8;
commit;
